<?php
/*
Plugin Name: Expiration Notice
Plugin URI: http://katzplus.com/
Description: 最終更新日から一定期間経過した記事に対して、指定日数以上経過していることを表示します。
Author: katz
Version: 0.3
Author URI: http://katzplus.com/
*/

// 実際のショートコード用のソースここから
add_shortcode('exp_notice', 'katzExpNoticeAdd');
function katzExpNoticeAdd($param) {
  // shortcodeからの値を取得 or デフォルト値を採用
  extract(
    shortcode_atts(
      array( 'y' => 'y'
            ,'m' => 'm'
            ,'d' => 'd'
            ,'h' => 'h'
            ,'i' => 'i'
            ,'s' => 's'
            ,'limit' => "0000/00/00 00:00:00"
      )
      , $param
    )
  );

  // 該当コンテンツの更新日時を取得、分解
  $katz_en_last_modified = get_the_modified_time('Y-m-d H:i:s');
  $katz_en_last_mod = explode(" ", $katz_en_last_modified);
  $katz_en_last_mod_date = explode("-", $katz_en_last_mod[0]);
  $katz_en_last_mod_time = explode(":", $katz_en_last_mod[1]);

  // ymdhis を確定させる
  if ($limit == "0000/00/00 00:00:00") {
    // すべて「ymdhis」だったらデフォルト値を採用
    if (($y.$m.$d.$h.$i.$s) == "ymdhis") {
      $y = intval(get_option('katz_en_default_year'));
      $m = intval(get_option('katz_en_default_month'));
      $d = intval(get_option('katz_en_default_day'));
      $h = intval(get_option('katz_en_default_hour'));
      $i = intval(get_option('katz_en_default_minute'));
      $s = intval(get_option('katz_en_default_second'));
    // 「ymdhis」でなかったら指定値と0を採用
    } else {
      $y = (is_numeric($y)) ? intval($y) : 0;
      $m = (is_numeric($m)) ? intval($m) : 0;
      $d = (is_numeric($d)) ? intval($d) : 0;
      $h = (is_numeric($h)) ? intval($h) : 0;
      $i = (is_numeric($i)) ? intval($i) : 0;
      $s = (is_numeric($s)) ? intval($s) : 0;
    }
    // 有効期限の年月日時分秒を割り出す
    $katz_en_y = intval($katz_en_last_mod_date[0]) + $y;
    $katz_en_m = intval($katz_en_last_mod_date[1]) + $m;
    $katz_en_d = intval($katz_en_last_mod_date[2]) + $d;
    $katz_en_h = intval($katz_en_last_mod_time[0]) + $h;
    $katz_en_i = intval($katz_en_last_mod_time[1]) + $i;
    $katz_en_s = intval($katz_en_last_mod_time[2]) + $s;
  } else {
    if (preg_match("/[^\d\/\s-:_]+/", $limit)) {
      $katz_en_y = intval(get_option('katz_en_default_year'));
      $katz_en_m = intval(get_option('katz_en_default_month'));
      $katz_en_d = intval(get_option('katz_en_default_day'));
      $katz_en_h = intval(get_option('katz_en_default_hour'));
      $katz_en_i = intval(get_option('katz_en_default_minute'));
      $katz_en_s = intval(get_option('katz_en_default_second'));
    } else {
      switch (strlen($limit)) {
        case 19 :
          $katz_en_y = intval(substr($limit, 0, 4));
          $katz_en_m = intval(substr($limit, 5, 2));
          $katz_en_d = intval(substr($limit, 8, 2));
          $katz_en_h = intval(substr($limit, 11, 2));
          $katz_en_i = intval(substr($limit, 14, 2));
          $katz_en_s = intval(substr($limit, 17, 2));
          break;
        case 15 :
          $katz_en_y = intval(substr($limit, 0, 4));
          $katz_en_m = intval(substr($limit, 4, 2));
          $katz_en_d = intval(substr($limit, 6, 2));
          $katz_en_h = intval(substr($limit, 9, 2));
          $katz_en_i = intval(substr($limit, 11, 2));
          $katz_en_s = intval(substr($limit, 13, 2));
          break;
        case 14 :
          $katz_en_y = intval(substr($limit, 0, 4));
          $katz_en_m = intval(substr($limit, 4, 2));
          $katz_en_d = intval(substr($limit, 6, 2));
          $katz_en_h = intval(substr($limit, 8, 2));
          $katz_en_i = intval(substr($limit, 10, 2));
          $katz_en_s = intval(substr($limit, 12, 2));
          break;
        case 10 :
          $katz_en_y = intval(substr($limit, 0, 4));
          $katz_en_m = intval(substr($limit, 5, 2));
          $katz_en_d = intval(substr($limit, 8, 2));
          $katz_en_h = 0;
          $katz_en_i = 0;
          $katz_en_s = 0;
          break;
        case 8 :
          if (preg_match("/[^\d]+/", $limit)) {
            $katz_en_y = intval(date('Y'));
            $katz_en_m = intval(date('m'));
            $katz_en_d = intval(date('d'));
            $katz_en_h = intval(substr($limit, 0, 2));
            $katz_en_i = intval(substr($limit, 3, 2));
            $katz_en_s = intval(substr($limit, 6, 2));
          } else {
            $katz_en_y = intval(substr($limit, 0, 4));
            $katz_en_m = intval(substr($limit, 4, 2));
            $katz_en_d = intval(substr($limit, 6, 2));
            $katz_en_h = 0;
            $katz_en_i = 0;
            $katz_en_s = 0;
          }
          break;
        case 6 :
          $katz_en_y = intval(date('Y'));
          $katz_en_m = intval(date('m'));
          $katz_en_d = intval(date('d'));
          $katz_en_h = intval(substr($limit, 0, 2));
          $katz_en_i = intval(substr($limit, 2, 2));
          $katz_en_s = intval(substr($limit, 4, 2));
          break;
        default :
          $katz_en_y = $katz_en_last_mod_date[0];
          $katz_en_m = $katz_en_last_mod_date[1];
          $katz_en_d = $katz_en_last_mod_date[2];
          $katz_en_h = $katz_en_last_mod_time[0];
          $katz_en_i = $katz_en_last_mod_time[1];
          $katz_en_s = $katz_en_last_mod_time[2];
      }
    }
  }
  // 有効期日をmktimeで取得☆
  $katz_en_limit_ymdhis  = mktime($katz_en_h,$katz_en_i,$katz_en_s,$katz_en_m,$katz_en_d,$katz_en_y);

  // 更新日時をmktimeで取得☆
  $katz_en_modify_ymdhis = mktime($katz_en_last_mod_time[0],$katz_en_last_mod_time[1],$katz_en_last_mod_time[2],$katz_en_last_mod_date[1],$katz_en_last_mod_date[2],$katz_en_last_mod_date[0]);

  // 現在日時をmktimeで取得☆
  if (get_option('gmt_offset') !== intval(substr(date('O'), 0, 3))) {
    $katz_en_now_ymdhis    = time() + (intval(get_option('gmt_offset')) * 3600);
  } else {
    $katz_en_now_ymdhis    = time();
  }

  // 有効期日までの残り時間、経過時間も取得
  $katz_en_timeleft      = ($katz_en_limit_ymdhis - $katz_en_now_ymdhis) > 0 ? ($katz_en_limit_ymdhis - $katz_en_now_ymdhis) : 0;
  $katz_en_overtime      = ($katz_en_now_ymdhis - $katz_en_limit_ymdhis) > 0 ? ($katz_en_now_ymdhis - $katz_en_limit_ymdhis) : 0;

  // 有効期限が過ぎていたら有効期日経過後のメッセージを表示。過ぎていない場合は有効期日前のメッセージを表示。
  if (($katz_en_limit_ymdhis - $katz_en_now_ymdhis) > 0) {
    $ret = '<div class="non_expiration">'."\n".get_option('katz_en_mae_html')."\n</div>";
  } else {
    $ret = '<div class="expiration">'."\n".get_option('katz_en_ato_html')."\n</div>";
  }

  // 残り時間が１日を超えているか否かで表示をちょっと変える（「＊時間＊分」もしくは「＊日と＊時間」）
  if (($katz_en_timeleft / 86400) < 1) {
    $katz_en_timeleft_format = str_pad(floor($katz_en_timeleft / 3600), 2, "0", STR_PAD_LEFT)."時間".str_pad(floor(($katz_en_timeleft % 3600) / 60), 2, "0", STR_PAD_LEFT)."分";
  } else {
    $katz_en_timeleft_format = floor($katz_en_timeleft / 86400)."日と".str_pad(floor(($katz_en_timeleft % 86400) / 3600), 2, "0", STR_PAD_LEFT)."時間";
  }
  // 経過時間も１日を超えているか否かで表示をちょっと変える（「＊時間＊分」もしくは「＊日と＊時間」）
  if (($katz_en_overtime / 86400) < 1) {
    $katz_en_overtime_format = str_pad(floor($katz_en_overtime / 3600), 2, "0", STR_PAD_LEFT)."時間".str_pad(floor(($katz_en_overtime % 3600) / 60), 2, "0", STR_PAD_LEFT)."分";
  } else {
    $katz_en_overtime_format = floor($katz_en_overtime / 86400)."日と".str_pad(floor(($katz_en_overtime % 86400) / 3600), 2, "0", STR_PAD_LEFT)."時間";
  }

  // メッセージ中の期日表示部分を実際の期日に置き換える。
  $ret = preg_replace('/%target_date%/', date('Y/m/d H:i:s', $katz_en_limit_ymdhis), $ret);
  $ret = preg_replace('/%modified_date%/', date('Y/m/d H:i:s', $katz_en_modify_ymdhis), $ret);
  $ret = preg_replace('/%timeleft%/', $katz_en_timeleft_format, $ret);
  $ret = preg_replace('/%overtime%/', $katz_en_overtime_format, $ret);

  return $ret;
}
// 実際のショートコード用のソースここまで

// 管理画面用のソースここから
add_action('admin_menu', 'katzExpNoticeAdmin');
function katzExpNoticeAdmin() {
 add_options_page('Expiration Notice Configure', 'Expiration Notice', '0', __FILE__, 'katzExpNoticeAdminPage');
}
function katzExpNoticeAdminPage () {
  if ($_POST['action'] == "update") {
    $katz_en_default_year_post = intval($_POST['katz_en_default_year']);
    update_option('katz_en_default_year', $katz_en_default_year_post);
    $katz_en_default_month_post = intval($_POST['katz_en_default_month']);
    update_option('katz_en_default_month', $katz_en_default_month_post);
    $katz_en_default_day_post = intval($_POST['katz_en_default_day']);
    update_option('katz_en_default_day', $katz_en_default_day_post);
    $katz_en_default_hour_post = intval($_POST['katz_en_default_hour']);
    update_option('katz_en_default_hour', $katz_en_default_hour_post);
    $katz_en_default_minute_post = intval($_POST['katz_en_default_minute']);
    update_option('katz_en_default_minute', $katz_en_default_minute_post);
    $katz_en_default_second_post = intval($_POST['katz_en_default_second']);
    update_option('katz_en_default_second', $katz_en_default_second_post);

    $katz_en_mae_html_post = $_POST['katz_en_mae_html'];
    update_option('katz_en_mae_html', $katz_en_mae_html_post);
    $katz_en_ato_html_post = $_POST['katz_en_ato_html'];
    update_option('katz_en_ato_html', $katz_en_ato_html_post);

    $katz_en_mae_css_post = $_POST['katz_en_mae_css'];
    update_option('katz_en_mae_css', $katz_en_mae_css_post);
    $katz_en_ato_css_post = $_POST['katz_en_ato_css'];
    update_option('katz_en_ato_css', $katz_en_ato_css_post);
  }
  $katz_en_default_year = get_option('katz_en_default_year', '0');
  $katz_en_default_month = get_option('katz_en_default_month', '0');
  $katz_en_default_day = get_option('katz_en_default_day', '60');
  $katz_en_default_hour = get_option('katz_en_default_hour', '0');
  $katz_en_default_minute = get_option('katz_en_default_minute', '0');
  $katz_en_default_second = get_option('katz_en_default_second', '0');
  $katz_en_mae_html = get_option('katz_en_mae_html', 'このページは %target_date% まで有効です。');
  $katz_en_ato_html = get_option('katz_en_ato_html', 'このページの有効掲載期限は %target_date% までです。記載されていることの正確性を確認ねがいます。');
  $katz_en_mae_css = get_option('katz_en_mae_css', "text-align: center;
border: solid 1px #7aaeff;
background: #d0f0ff;
color: #222;
line-height: 18px;
margin-bottom: 18px;
padding: 1.5em;");
  $katz_en_ato_css = get_option('katz_en_ato_css', "text-align: center;
border: solid 1px #ff0000;
background: #ffe1ff;
color: #222;
line-height: 18px;
margin-bottom: 18px;
padding: 1.5em;");
?>
 <div class="wrap">
  <div id="icon-options-general" class="icon32">
   <br>
  </div>
  <h2>Expiration Notice Configure</h2>
  <form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>

  <h3>デフォルトの有効期日</h3>
   <table class="form-table" style="width: 480px;">
    <tr>
     <td style="width: 80px;"><input type="text" size="2" name="katz_en_default_year" value="<?=$katz_en_default_year; ?>" style="text-align:right;" />年</td>
     <td style="width: 80px;"><input type="text" size="2" name="katz_en_default_month" value="<?=$katz_en_default_month; ?>" style="text-align:right;" />月</td>
     <td style="width: 80px;"><input type="text" size="2" name="katz_en_default_day" value="<?=$katz_en_default_day; ?>" style="text-align:right;" />日</td>
     <td style="width: 80px;"><input type="text" size="2" name="katz_en_default_hour" value="<?=$katz_en_default_hour; ?>" style="text-align:right;" />時</td>
     <td style="width: 80px;"><input type="text" size="2" name="katz_en_default_minute" value="<?=$katz_en_default_minute; ?>" style="text-align:right;" />分</td>
     <td style="width: 80px;"><input type="text" size="2" name="katz_en_default_second" value="<?=$katz_en_default_second; ?>" style="text-align:right;" />秒</td>
    </tr>
   </table>
   <p>ショートコードに有効期日を指定しなかった場合、ここで指定した期日が使用されます。</p>

  <h3>表示するメッセージ</h3>
   <h4>有効期日前メッセージ</h4>
    <textarea name="katz_en_mae_html" cols="90" rows="2"><?=$katz_en_mae_html; ?></textarea>
   <h4>有効期日経過後メッセージ</h4>
    <textarea name="katz_en_ato_html" cols="90" rows="2"><?=$katz_en_ato_html; ?></textarea>
   <p>下記の置き換えパターンが使用できます。</p>
   <table width="300px">
    <tr>
     <th>有効期限</th>
     <td>%target_date%</td>
    </tr>
    <tr>
     <th>最終更新日時</th>
     <td>%modified_date%</td>
    </tr>
    <tr>
     <th>超過日時</th>
     <td>%overtime%</td>
    </tr>
    <tr>
     <th>残存日時</th>
     <td>%timeleft%</td>
    </tr>
   </table>

  <h3>メッセージのスタイルシート</h3>
   <h4>有効期日前メッセージのスタイルシート</h4>
    <textarea name="katz_en_mae_css" cols="90" rows="2"><?=$katz_en_mae_css; ?></textarea>
   <h4>有効期日経過後メッセージのスタイルシート</h4>
    <textarea name="katz_en_ato_css" cols="90" rows="2"><?=$katz_en_ato_css; ?></textarea>
   <p>スタイルシートを独自のものに変更することができます。</p>

   <input type="hidden" name="action" value="update" />
   <input type="hidden" name="page_options" value="katz_en_default_year,katz_en_default_month,katz_en_default_day,katz_en_default_hour,katz_en_default_minute,katz_en_default_second,katz_en_mae_html,katz_en_ato_html,katz_en_mae_css,katz_en_ato_css" />

   <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
   </p>
  </form>
 </div>
<?php
}
// 管理画面用のソースここまで

// スタイルシート読み込みのソースここから
add_action('wp_head', 'katzExpNoticeCss');
function katzExpNoticeCss() {
  echo '<style type="text/css">'."
<!--
.expiration {
".get_option('katz_en_ato_css')."
}
.non_expiration {
".get_option('katz_en_mae_css')."
}
 -->
</style>
";
}
// スタイルシート読み込みのソースここまで
?>